D - Cow Ski Area

Description

Farmer John‘s cousin, Farmer Ron, who lives in the mountains of Colorado, has recently taught his cows to ski. Unfortunately, his cows are somewhat timid and are afraid to ski among crowds of people at the local resorts, so FR has decided to construct his own private ski area behind his farm.

FR‘s ski area is a rectangle of width W and length L of ‘land squares‘ (1 <= W <= 500; 1 <= L <= 500). Each land square is an integral height H above sea level (0 <= H <= 9,999). Cows can ski horizontally and vertically between any two adjacent land squares, but never diagonally. Cows can ski from a higher square to a lower square but not the other way and they can ski either direction between two adjacent squares of the same height.

FR wants to build his ski area so that his cows can travel between any two squares by a combination of skiing (as described above) and ski lifts. A ski lift can be built between any two squares of the ski area, regardless of height. Ski lifts are bidirectional. Ski lifts can cross over each other since they can be built at varying heights above the ground, and multiple ski lifts can begin or end at the same square. Since ski lifts are expensive to build, FR wants to minimize the number of ski lifts he has to build to allow his cows to travel between all squares of his ski area.

Find the minimum number of ski lifts required to ensure the cows can travel from any square to any other square via a combination of skiing and lifts.

Input

* Line 1: Two space-separated integers: W and L

* Lines 2..L+1: L lines, each with W space-separated integers corresponding to the height of each square of land.

Output

* Line 1: A single integer equal to the minimal number of ski lifts FR needs to build to ensure that his cows can travel from any square to any other square via a combination of skiing and ski lifts

Sample Input

9 3
1 1 1 2 2 2 1 1 1
1 2 1 2 3 2 1 2 1
1 1 1 2 2 2 1 1 1

Sample Output

3

Hint

This problem has huge input data,use scanf() instead of cin to read data to avoid time limit exceed.

OUTPUT DETAILS:

FR builds the three lifts. Using (1, 1) as the lower-left corner, 
the lifts are (3, 1) <-> (8, 2), (7, 3) <-> (5, 2), and (1, 3) <-> 
(2, 2). All locations are now connected. For example, a cow wishing 
to travel from (9, 1) to (2, 2) would ski (9, 1) -> (8, 1) -> (7, 
1) -> (7, 2) -> (7, 3), take the lift from (7, 3) -> (5, 2), ski 
(5, 2) -> (4, 2) -> (3, 2) -> (3, 3) -> (2, 3) -> (1, 3), and then 
take the lift from (1, 3) - > (2, 2). There is no solution using

fewer than three lifts.

[cpp] view plaincopyprint?

  1. #include<stdio.h>
  2. #include<string.h>
  3. #include<stack>
  4. #define INF 1000010
  5. #define P 261010
  6. using namespace std;
  7. stack<int>S;
  8. int a[550][550],map[P][10],low[P],dfn[P];
  9. int instack[P];
  10. int bnt,be[P],n,m;
  11. int index,in[P],out[P];
  12. void build(){
  13. for(int i=1;i<=n;i++)
  14. for(int j=1;j<=m;j++){
  15. if(a[i][j]>=a[i-1][j])map[j+m*i-m][++map[j+m*i-m][0]] = j+(i-2)*m;
  16. if(a[i][j]>=a[i+1][j])map[j+m*i-m][++map[j+m*i-m][0]] = j+i*m;
  17. if(a[i][j]>=a[i][j+1])map[j+m*i-m][++map[j+m*i-m][0]] = j+(i-1)*m+1;
  18. if(a[i][j]>=a[i][j-1])map[j+m*i-m][++map[j+m*i-m][0]] = j+(i-1)*m-1;
  19. }
  20. }
  21. void tarjan(int i){
  22. dfn[i] = low[i] = ++index;
  23. S.push(i);
  24. instack[i] = 1;
  25. for(int j = 1;j<=map[i][0];j++){
  26. int k = map[i][j];
  27. if(!dfn[k]){
  28. tarjan(k);
  29. low[i] = min(low[i],low[k]);
  30. }
  31. else if(instack[k]){
  32. low[i] = min(low[i],dfn[k]);
  33. }
  34. }
  35. if(dfn[i]==low[i]){
  36. bnt++;
  37. int kk;
  38. do{
  39. kk = S.top();
  40. S.pop();
  41. instack[kk] = 0;
  42. be[kk] = bnt;
  43. }while(i!=kk);
  44. }
  45. }
  46. int main(){
  47. while(~scanf("%d%d",&m,&n)){
  48. int ans,ans1;
  49. memset(dfn,0,sizeof(dfn));
  50. memset(in,0,sizeof(in));
  51. memset(out,0,sizeof(out));
  52. memset(instack,0,sizeof(instack));
  53. bnt = ans = ans1 = index = 0;
  54. for(int i=0;i<=n+1;i++)a[i][0] = a[i][m+1] = INF;
  55. for(int j=0;j<=m+1;j++)a[0][j] = a[n+1][j] = INF;
  56. for(int i=1;i<=n;i++){
  57. for(int j=1;j<=m;j++){
  58. scanf("%d",&a[i][j]);
  59. map[j+(i-1)*m][0] = 0;
  60. }
  61. }
  62. build();
  63. for(int i=1;i<=n*m;i++)
  64. if(!dfn[i])
  65. tarjan(i);
  66. for(int i=1;i<=n*m;i++){
  67. for(int j =1;j<=map[i][0];j++)
  68. if(be[i]!=be[map[i][j]]){
  69. out[be[i]]++;
  70. in[be[map[i][j]]]++;
  71. }
  72. }
  73. for(int i=1;i<=bnt;i++){
  74. if(out[i]==0)ans++;
  75. if(in[i]==0)ans1++;
  76. }
  77. if(bnt==1)printf("0\n");
  78. else printf("%d\n",max(ans,ans1));
  79. }
  80. }

[cpp] view plaincopyprint?

  1. 在POJ能过,在杭电就过不了,是什么原因啊,。。。。。。??!坑爹啊
时间: 2024-10-15 02:58:46

D - Cow Ski Area的相关文章

POJ 2375 Cow Ski Area(强连通)

POJ 2375 Cow Ski Area 题目链接 题意:给定一个滑雪场,每个点能向周围4个点高度小于等于这个点的点滑,现在要建电缆,使得任意两点都有路径互相可达,问最少需要几条电缆 思路:强连通缩点,每个点就是一个点,能走的建边,缩点后找入度出度为0的个数的最大值就是答案,注意一开始就强连通了答案应该是0 代码: #include <cstdio> #include <cstring> #include <stack> #include <algorithm&

POJ2375 Cow Ski Area (强连通)(缩点)

Cow Ski Area Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 3323   Accepted: 919 Description Farmer John's cousin, Farmer Ron, who lives in the mountains of Colorado, has recently taught his cows to ski. Unfortunately, his cows are some

POJ2375 Cow Ski Area 【强连通分量】+【DFS】

Cow Ski Area Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 2323   Accepted: 660 Description Farmer John's cousin, Farmer Ron, who lives in the mountains of Colorado, has recently taught his cows to ski. Unfortunately, his cows are some

POJ2375 Cow Ski Area (添最少边构造强连通分量的某个与入度出度相关的结论)

题意:本题描述了一片滑雪场,并且规定奶牛从一个点只能向它相邻的并且高度不大于它的点运动,现在想要在某些点对之间加上缆车使得奶牛也可以从较低点到达较高点,问最少需要多少辆这样的缆车就可以使得奶牛可以从任意一个点运动到滑雪场的每个角落. 思路:即问至少加多少条边使图变成强联通图,先缩点成DAG. 不难知道强连通分量的所有节点的入度和出度均不为0,可以统计DAG上的入度和出度为0的个数分别是a,b.然后答案即为max(a,b). 只是发现入度为0和出度为0的点可以按某种方式相连接总能构造出一个强连通分

POJ 2375 Cow Ski Area (强连通分量)

题目地址:POJ 2375 对每一个点向与之相邻并h小于该点的点加有向边. 然后强连通缩点.问题就转化成了最少加几条边使得图为强连通图,取入度为0和出度为0的点数的较大者就可以.注意,当强连通分量仅仅有一个的时候.答案是0,而不是1. 代码例如以下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <algorithm> #in

POJ 2375 Cow Ski Area【tarjan】

题目大意:一个W*L的山,每个山有个高度,当且仅当一个山不比它相邻(有公共边的格子)的山矮时能够滑过去,现在可以装化学电梯来无视山的高度滑雪,问最少装多少电梯使得任意两点都可到达 思路:最后一句话已经把强连通模型裸裸地说出来了 那问题变成了一个图最小加几条边变成强连通图的经典问题,比较一下出度为0和入度为0的点的个数的大小即可,还有个特例只有一个SCC的情况 #include<cstdio> #include<string.h> #include<iostream> #

POJ2375 Cow Ski Area【Tarjan】【强连通分量】

题目链接: http://poj.org/problem?id=2375 题目大意: 有一片供奶牛滑雪的滑雪场,可供滑雪的区域是W(宽)*L(长)的矩阵.上边有W*L个点.规定 奶牛从一个点只能向它上.下.左.右相邻的并且高度不大于它的点运动.现在想要在某些 点对之间架设缆车,使得奶牛可以从较低的地方想较高的地方运动,那么问题来了:最少需 要多少辆这样的缆车就可以使奶牛从每个点运动到可供滑雪区域的每个角落. 思路: 把奶牛符合从点u移动到点v的条件当做一条单向边.那么所有点和边就可以构成有向图.

杭电ACM分类

杭电ACM分类: 1001 整数求和 水题1002 C语言实验题——两个数比较 水题1003 1.2.3.4.5... 简单题1004 渊子赛马 排序+贪心的方法归并1005 Hero In Maze 广度搜索1006 Redraiment猜想 数论:容斥定理1007 童年生活二三事 递推题1008 University 简单hash1009 目标柏林 简单模拟题1010 Rails 模拟题(堆栈)1011 Box of Bricks 简单题1012 IMMEDIATE DECODABILITY

题单二:图论500

http://wenku.baidu.com/link?url=gETLFsWcgddEDRZ334EJOS7qCTab94qw5cor8Es0LINVaGMSgc9nIV-utRIDh--2UwRLvsvJ5tXFjbdpzbjygEdpGehim1i5BfzYgYWxJmu ==========  以下是最小生成树+并查集=========================[HDU]1213         How Many Tables        基础并查集★1272         小